package com.xxl.job.admin.core.thread;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.xxl.job.admin.core.conf.XxlJobAdminConfig;
import com.xxl.job.admin.core.model.XxlJobInfo;
import com.xxl.job.admin.core.scheduler.MisfireStrategyEnum;
import com.xxl.job.admin.core.thread.JobScheduleHelper;
import com.xxl.job.admin.core.thread.JobTriggerPoolHelper;
import com.xxl.job.admin.core.trigger.TriggerTypeEnum;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.util.Date;
import java.util.List;
import java.util.concurrent.TimeUnit;

class null implements Runnable {
  public void run() {
    try {
      TimeUnit.MILLISECONDS.sleep(5000L - System.currentTimeMillis() % 1000L);
    } catch (Throwable e) {
      if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
        JobScheduleHelper.access$100().error(e.getMessage(), e); 
    } 
    JobScheduleHelper.access$100().info(">>>>>>>>> init xxl-job admin scheduler success.");
    int preReadCount = (XxlJobAdminConfig.getAdminConfig().getTriggerPoolFastMax() + XxlJobAdminConfig.getAdminConfig().getTriggerPoolSlowMax()) * 20;
    while (!JobScheduleHelper.access$000(JobScheduleHelper.this)) {
      long start = System.currentTimeMillis();
      Connection conn = null;
      Boolean connAutoCommit = null;
      PreparedStatement preparedStatement = null;
      boolean preReadSuc = true;
      try {
        conn = XxlJobAdminConfig.getAdminConfig().getDataSource().getConnection();
        connAutoCommit = Boolean.valueOf(conn.getAutoCommit());
        conn.setAutoCommit(false);
        preparedStatement = conn.prepareStatement("select * from xxl_job_lock where lock_name = 'schedule_lock' for update");
        preparedStatement.execute();
        long nowTime = System.currentTimeMillis();
        List<XxlJobInfo> scheduleList = XxlJobAdminConfig.getAdminConfig().getXxlJobInfoDao().scheduleJobQuery(nowTime + 5000L, preReadCount);
        if (scheduleList != null && scheduleList.size() > 0) {
          for (XxlJobInfo jobInfo : scheduleList) {
            if (nowTime > jobInfo.getTriggerNextTime() + 5000L) {
              JobScheduleHelper.access$100().warn(">>>>>>>>>>> xxl-job, schedule misfire, jobId = " + jobInfo.getId());
              MisfireStrategyEnum misfireStrategyEnum = MisfireStrategyEnum.match(jobInfo.getMisfireStrategy(), MisfireStrategyEnum.DO_NOTHING);
              if (MisfireStrategyEnum.FIRE_ONCE_NOW == misfireStrategyEnum) {
                JobTriggerPoolHelper.trigger(jobInfo.getId(), TriggerTypeEnum.MISFIRE, -1, null, null, null);
                JobScheduleHelper.access$100().debug(">>>>>>>>>>> xxl-job, schedule push trigger : jobId = " + jobInfo.getId());
              } 
              JobScheduleHelper.access$200(JobScheduleHelper.this, jobInfo, new Date());
              continue;
            } 
            if (nowTime > jobInfo.getTriggerNextTime()) {
              JobTriggerPoolHelper.trigger(jobInfo.getId(), TriggerTypeEnum.CRON, -1, null, null, null);
              JobScheduleHelper.access$100().debug(">>>>>>>>>>> xxl-job, schedule push trigger : jobId = " + jobInfo.getId());
              JobScheduleHelper.access$200(JobScheduleHelper.this, jobInfo, new Date());
              if (jobInfo.getTriggerStatus() == 1 && nowTime + 5000L > jobInfo.getTriggerNextTime()) {
                int i = (int)(jobInfo.getTriggerNextTime() / 1000L % 60L);
                JobScheduleHelper.access$300(JobScheduleHelper.this, i, jobInfo.getId());
                JobScheduleHelper.access$200(JobScheduleHelper.this, jobInfo, new Date(jobInfo.getTriggerNextTime()));
              } 
              continue;
            } 
            int ringSecond = (int)(jobInfo.getTriggerNextTime() / 1000L % 60L);
            JobScheduleHelper.access$300(JobScheduleHelper.this, ringSecond, jobInfo.getId());
            JobScheduleHelper.access$200(JobScheduleHelper.this, jobInfo, new Date(jobInfo.getTriggerNextTime()));
          } 
          for (XxlJobInfo jobInfo : scheduleList)
            XxlJobAdminConfig.getAdminConfig().getXxlJobInfoDao().scheduleUpdate(jobInfo); 
        } else {
          preReadSuc = false;
        } 
      } catch (Throwable e) {
        if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
          JobScheduleHelper.access$100().error(">>>>>>>>>>> xxl-job, JobScheduleHelper#scheduleThread error:{}", e); 
      } finally {
        if (conn != null) {
          try {
            conn.commit();
          } catch (Throwable e) {
            if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
              JobScheduleHelper.access$100().error(e.getMessage(), e); 
          } 
          try {
            conn.setAutoCommit(connAutoCommit.booleanValue());
          } catch (Throwable e) {
            if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
              JobScheduleHelper.access$100().error(e.getMessage(), e); 
          } 
          try {
            conn.close();
          } catch (Throwable e) {
            if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
              JobScheduleHelper.access$100().error(e.getMessage(), e); 
          } 
        } 
        if (null != preparedStatement)
          try {
            preparedStatement.close();
          } catch (Throwable e) {
            if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
              JobScheduleHelper.access$100().error(e.getMessage(), e); 
          }  
      } 
      long cost = System.currentTimeMillis() - start;
      if (cost < 1000L)
        try {
          TimeUnit.MILLISECONDS.sleep((preReadSuc ? 1000L : 5000L) - System.currentTimeMillis() % 1000L);
        } catch (Throwable e) {
          if (!JobScheduleHelper.access$000(JobScheduleHelper.this))
            JobScheduleHelper.access$100().error(e.getMessage(), e); 
        }  
    } 
    JobScheduleHelper.access$100().info(">>>>>>>>>>> xxl-job, JobScheduleHelper#scheduleThread stop");
  }
}
